Subject: page cache is not influenced by tt_content.starttime/endtime

Description

The actual caching meachanism works like that:

- page is generated

- expiredate is calculated (by clearAtMidNight or page caching config,
usually set to generating time + one day)

- if a page is requested, TYPOS3 checks wether the cache is expired or the
page starttime/endtime should take effect.

So an content element has no influence on caching time.
If a page is cached at 2pm (with 24hours cache-expire) and there is a
content element with an starttime at 3pm on that day, that content element

will be visible first at 2pm the next day (when the page cache expires).

As an proof of concept i wrote an extension:
http://forge.typo3.org/projects/show/extension-cacheexpire

With that extension the expire-timestamp of the pagecache will be calculated based on starttime/endtime of all content elements on
that page. Deleted, hidden, starttime, endtime and group-permissions are respected.

For different tables then tt_content it is possible to use an hook. With that extension i provide an very simple class which hooks in and
takes care of tt_news elements (if there is a plugin on that page).

I made an patch of that extension for integrating into the core.
(issue imported from #M9284)

Related issues:

related to Core - Bug # 20473: Starttime/endtime is not taken into account wh... Closed 2011-06-05
related to Core - Bug # 23180: Starttime/endtime for pages and content is not... Rejected 2010-07-14
History

#1 - 2008-09-09 13:37 - Martin Holtz

The new 9284.diff is from Ingo Renner in the core mailinglist

#2 - 2008-10-16 21:53 - Martin Holtz

another try:
http://forge.typo3.org/projects/show/extension-cacheexpire

i removed the hook and the sql-query and reduced this patch that it only reacts on

$GLOBALS[' TSFE"->cacheExpires

#3 - 2008-10-29 21:06 - Martin Holtz

i uploaded another patch

this time with an additional function to set cacheExpires Timestamp

#4 - 2008-11-28 20:24 - Francois Suter

Attaching a corrected patch, as submitted in the core list

#5 - 2008-11-28 20:30 - Francois Suter

| have tested this patch with a quickly put together extension, which | am attaching here. The extension is called "xnews". It's a FE plugin that just gets
the 10 latest records from the tt_news table (so you need tt_news installed too). There's no configuration at all. Just insert an instance of xnews on
some page and display the page. You should a list of 10 news items plus an indication of when the next update should take place, i.e. when the cache
will expire.

To test properly you obviously need to have at least 1 tt_news with a starttime in the future.

You can check if that matches the information stored in the cache_pages table.

The xnews extension actually relies on an (as yet) unpublished extension called "overlays" (and this is even a modified version just for testing this
patch). So you need to install "overlays" too. "overlays" is used to simplify querying the DB in particular in a multilingual setup. In this case | added a
method for simply getting all records in the future and calculating a precise expiry time for the cache.

#6 - 2009-05-19 10:30 - Dmitry Dulepov

Please, see also #20473. It provides an automatic solution to this problem.

#7 - 2009-05-19 21:17 - Martin Holtz
hi dmitry,
in my eyes

#20473
is an better approach.

#8 - 2011-07-14 13:55 - Xavier Perseguers
- Target version changed from 4.6.0 to 4.6.0-betal

#9 - 2011-07-14 23:36 - Stefan Neufeind

The functionality described in this issue-description is what #20473 (already commited now) offers. So I'd say we should close this one.
#10 - 2011-07-15 00:16 - Christian Kuhn
- Status changed from New to Closed

Solved with #20473

#11 - 2013-06-01 14:45 - Ernesto Baschny

- Target version deleted (4.6.0-betal)
